[中文文档](http://tinymce.ax-z.cn/) [英文文档](https://www.tiny.cloud/docs/integrations/vue/#configuringtheeditor) [当前版本文档](https://www.tiny.cloud/docs/)

### API

| 参数                |                           说明                           |         类型          |                                       默认值                                        |
| ------------------- | :------------------------------------------------------: | :-------------------: | :---------------------------------------------------------------------------------: |
| value               |                          默认值                          |        string         |                                         ""                                          |
| selector            |                          选择器                          |        string         |                                      .tinymce                                       |
| resize              |                         调整大小                         | boolean &#124; 'both' |                                        false                                        |
| height              |                           高度                           | number &#124; string  |                                         500                                         |
| width               |                           宽度                           | number &#124; string  |                                          -                                          |
| minWidth            |                         最小宽度                         | number &#124; string  |                                          -                                          |
| minHeight           |                         最小高度                         | number &#124; string  |                                          -                                          |
| maxWidth            |                         最大宽度                         | number &#124; string  |                                          -                                          |
| maxHeight           |                         最大高度                         | number &#124; string  |                                          -                                          |
| menubar             |                        菜单栏配置                        | boolean &#124; string |                                        false                                        |
| toolbar             |                        工具栏配置                        |         array         |   例:['fullscreen file media image undo redo restoredraft &#124; cut copy paste']   |
| fontFormats         |                         字体样式                         |        string         |         例: "思源宋体=tonjay;思源黑=NotoSans SC;微软雅黑=Microsoft YaHei;"          |
| fontsizeFormats     |                         字体大小                         |        string         |                      例: "12px 14px 16px 18px 20px 24px 28px"                       |
| statusbar           |                    元素路径和字数统计                    |        boolean        |                                        false                                        |
| elementPath         |                         元素路径                         |        boolean        |                                        false                                        |
| filePickerTypes     |                      文件选择器类型                      |        string         |                                  file image media                                   |
| placeholder         |                         提示文字                         |        string         |                                   在这里输入文字                                    |
| action              |                         上传地址                         |        string         |                                          -                                          |
| headers             |                         上传地址                         |        object         |           使用 xhr 上传，默认不设置，如上传接口需鉴权可设置 Authorization           |
| name                |                       文件上传名称                       |        string         |                                     fileContent                                     |
| data                |                         请求参数                         |        object         |                                          -                                          |
| imageSize           |                       图片文件大小                       |        number         |                                          2                                          |
| imageAccept         |                       图片文件格式                       |        number         |                          ['.gif', '.jpg', '.jpeg', '.png']                          |
| mediaSize           |                       媒体文件大小                       |        number         |                                         10                                          |
| mediaAccept         |                       媒体文件格式                       |        number         |                                  ['.mp3', '.mp4']                                   |
| fileSize            |                         文件大小                         |        number         |                                         10                                          |
| fileAccept          |                         文件格式                         |         array         | ['.pdf', '.doc', '.docx', '.xls', '.xlsx', '.ppt', '.pptx', '.txt', '.zip', '.rar'] |
| externalPlugins     |                         插件地址                         |        object         |     {advlist: new URL(`/plugins/advlist/plugin.min.js`, import.meta.url).href,}     |
| languageUrl         |                        语言包地址                        |        string         |                                          -                                          |
| themeUrl            |                        编辑器主题                        |        string         |                                          -                                          |
| skinUrl             |                        编辑器皮肤                        |        string         |                                          -                                          |
| iconsUrl            |                        编辑器图标                        |        string         |                                          -                                          |
| contentCss          |                      编辑器内容样式                      |        string         |                                          -                                          |
| imagesUploadHandler |                    自定义图片上传函数                    |       Function        |          (blobInfo: BlobInfo, success: Success, failure: Failure) => void           |
| backFileUrlName     | 上传文件后，返回链接字段名（用于取值回显到富文本编辑器） |       Function        |                                       fileUrl                                       |

### 示例

```ts
<template>
  <div class="test">
    <editor
      v-model:value="test"
      action="/apiproductcenter/product/center/cms/v1/0/common/upload"
      :data="{ type: 'GOODS_PDF', targetType: 'GOODS' }"
    />
  </div>
</template>

<script lang="ts">
import { defineComponent, ref } from 'vue'
import Editor from '@/components/Editor'
export default defineComponent({
  name: 'index',
  components: {
    Editor,
  },
  setup() {
    const test = ref('测试')
    return {
      test,
    }
  },
})
</script>
```
