/**
 * Copyright (c) Tiny Technologies, Inc. All rights reserved.
 * Licensed under the LGPL or a commercial license.
 * For LGPL see License.txt in the project root for license information.
 * For commercial licenses see https://www.tiny.cloud/
 *
 * Version: 5.10.5 (2022-05-25)
 */
!(function () {
  'use strict'
  function k(e) {
    return /^[(\[{ \u00a0]$/.test(e)
  }
  function w(e) {
    return 3 === e.nodeType
  }
  function i(e) {
    return 1 === e.nodeType
  }
  function o(e, t) {
    var n
    return t < 0 && (t = 0), !w(e) || ((n = e.data.length) < t && (t = n)), t
  }
  function y(e, t, n) {
    !i(t) || t.hasChildNodes() ? e.setStart(t, o(t, n)) : e.setStartBefore(t)
  }
  function v(e, t, n) {
    !i(t) || t.hasChildNodes() ? e.setEnd(t, o(t, n)) : e.setEndAfter(t)
  }
    // 补充判断浏览器方法---------------
    function V(e) {
      function t(e) {
        return function () {
          return n === e
        }
      }
      var n = e.current,
        r = e.version
      return {
        current: n,
        version: r,
        isEdge: t('Edge'),
        isChrome: t('Chrome'),
        isIE: t('IE'),
        isOpera: t('Opera'),
        isFirefox: t(ne),
        isSafari: t('Safari'),
      }
    }
    function W(e) {
      function t(e) {
        return function () {
          return n === e
        }
      }
      var n = e.current,
        r = e.version
      return {
        current: n,
        version: r,
        isWindows: t(ie),
        isiOS: t('iOS'),
        isAndroid: t(ae),
        isOSX: t('OSX'),
        isLinux: t('Linux'),
        isSolaris: t(se),
        isFreeBSD: t(ue),
        isChromeOS: t(ce),
      }
    }
    function S(e) {
      return function () {
        return e
      }
    }
    function U(e, t) {
      return -1 !== e.indexOf(t)
    }
    function _(t) {
      return function (e) {
        return U(e, t)
      }
    }
    var ee = /.*?version\/\ ?([0-9]+)\.([0-9]+).*/,
    te = {
      browsers: S([
        {
          name: 'Edge',
          versionRegexes: [/.*?edge\/ ?([0-9]+)\.([0-9]+)$/],
          search: function (e) {
            return U(e, 'edge/') && U(e, 'chrome') && U(e, 'safari') && U(e, 'applewebkit')
          },
        },
        {
          name: 'Chrome',
          brand: 'Chromium',
          versionRegexes: [/.*?chrome\/([0-9]+)\.([0-9]+).*/, ee],
          search: function (e) {
            return U(e, 'chrome') && !U(e, 'chromeframe')
          },
        },
        {
          name: 'IE',
          versionRegexes: [/.*?msie\ ?([0-9]+)\.([0-9]+).*/, /.*?rv:([0-9]+)\.([0-9]+).*/],
          search: function (e) {
            return U(e, 'msie') || U(e, 'trident')
          },
        },
        {
          name: 'Opera',
          versionRegexes: [ee, /.*?opera\/([0-9]+)\.([0-9]+).*/],
          search: _('opera'),
        },
        {
          name: 'Firefox',
          versionRegexes: [/.*?firefox\/\ ?([0-9]+)\.([0-9]+).*/],
          search: _('firefox'),
        },
        {
          name: 'Safari',
          versionRegexes: [ee, /.*?cpu os ([0-9]+)_([0-9]+).*/],
          search: function (e) {
            return (U(e, 'safari') || U(e, 'mobile/')) && U(e, 'applewebkit')
          },
        },
      ]),
      oses: S([
        {
          name: 'Windows',
          search: _('win'),
          versionRegexes: [/.*?windows\ nt\ ?([0-9]+)\.([0-9]+).*/],
        },
        {
          name: 'iOS',
          search: function (e) {
            return U(e, 'iphone') || U(e, 'ipad')
          },
          versionRegexes: [
            /.*?version\/\ ?([0-9]+)\.([0-9]+).*/,
            /.*cpu os ([0-9]+)_([0-9]+).*/,
            /.*cpu iphone os ([0-9]+)_([0-9]+).*/,
          ],
        },
        {
          name: 'Android',
          search: _('android'),
          versionRegexes: [/.*?android\ ?([0-9]+)\.([0-9]+).*/],
        },
        {
          name: 'OSX',
          search: _('mac os x'),
          versionRegexes: [/.*?mac\ os\ x\ ?([0-9]+)_([0-9]+).*/],
        },
        { name: 'Linux', search: _('linux'), versionRegexes: [] },
        { name: 'Solaris', search: _('sunos'), versionRegexes: [] },
        { name: 'FreeBSD', search: _('freebsd'), versionRegexes: [] },
        {
          name: 'ChromeOS',
          search: _('cros'),
          versionRegexes: [/.*?chrome\/([0-9]+)\.([0-9]+).*/],
        },
      ]),
    },
    ne = 'Firefox',
    re = function () {
      return V({ current: void 0, version: G.unknown() })
    },
    oe = V,
    ie = (S('Edge'), S('Chrome'), S('IE'), S('Opera'), S(ne), S('Safari'), 'Windows'),
    ae = 'Android',
    se = 'Solaris',
    ue = 'FreeBSD',
    ce = 'ChromeOS',
    fe = function () {
      return W({ current: void 0, version: G.unknown() })
    }
    // ---------------
  function r(e, t) {
    var n,
      i,
      o,
      r,
      a,
      f = e.getParam('autolink_pattern', A),
      s = e.getParam('default_link_target', !1)
    if (null === e.dom.getParent(e.selection.getNode(), 'a[href]')) {
      var d = e.selection.getRng().cloneRange()
      if (d.startOffset < 5) {
        if (!(r = d.endContainer.previousSibling)) {
          if (!d.endContainer.firstChild || !d.endContainer.firstChild.nextSibling) return
          r = d.endContainer.firstChild.nextSibling
        }
        if ((y(d, r, (a = r.length)), v(d, r, a), d.endOffset < 5)) return
        ;(n = d.endOffset), (i = r)
      } else {
        if (!w((i = d.endContainer)) && i.firstChild) {
          for (; !w(i) && i.firstChild; ) i = i.firstChild
          w(i) && (y(d, i, 0), v(d, i, i.nodeValue.length))
        }
        n = 1 === d.endOffset ? 2 : d.endOffset - 1 - t
      }
      for (
        var l = n;
        y(d, i, 2 <= n ? n - 2 : 0),
          v(d, i, 1 <= n ? n - 1 : 0),
          --n,
          !k(d.toString()) && 0 <= n - 2;

      );
      k(d.toString())
        ? (y(d, i, n), v(d, i, l), (n += 1))
        : (0 === d.startOffset ? y(d, i, 0) : y(d, i, n), v(d, i, l)),
        (u = d.toString()),
        /[?!,.;:]/.test(u.charAt(u.length - 1)) && v(d, i, l - 1)
      var u,
        c,
        g,
        h,
        C = (u = d.toString().trim()).match(f),
        m = e.getParam('link_default_protocol', 'http', 'string')
      C &&
        ((g = c = C[0]).length >= (h = 'www.').length && g.substr(0, 0 + h.length) === h
          ? (c = m + '://' + c)
          : -1 === c.indexOf('@') ||
            /^([A-Za-z][A-Za-z\d.+-]*:\/\/)|mailto:/.test(c) ||
            (c = 'mailto:' + c),
        (o = e.selection.getBookmark()),
        e.selection.setRng(d),
        e.execCommand('createlink', !1, c),
        !1 !== s && e.dom.setAttrib(e.selection.getNode(), 'target', s),
        e.selection.moveToBookmark(o),
        e.nodeChanged())
    }
  }
  var e = tinymce.util.Tools.resolve('tinymce.PluginManager'),
    a = tinymce.util.Tools.resolve('tinymce.Env'),
    A = new RegExp(
      '^' +
        /(?:[A-Za-z][A-Za-z\d.+-]{0,14}:\/\/(?:[-.~*+=!&;:'%@?^${}(),\w]+@)?|www\.|[-;:&=+$,.\w]+@)[A-Za-z\d-]+(?:\.[A-Za-z\d-]+)*(?::\d+)?(?:\/(?:[-+~=.,%()\/\w]*[-+~=%()\/\w])?)?(?:\?(?:[-.~*+=!&;:'%@?^${}(),\/\w]+))?(?:#(?:[-.~*+=!&;:'%@?^${}(),\/\w]+))?/g
          .source +
        '$',
      'i'
    )
  e.add('autolink', function (e) {
    var t, n
    ;(t = e).on('keydown', function (e) {
      if (13 === e.keyCode) return r(t, -1)
    }),
      a.browser.isIE()
        ? t.on('focus', function () {
            if (!n) {
              n = !0
              try {
                t.execCommand('AutoUrlDetect', !1, !0)
              } catch (e) {}
            }
          })
        : (t.on('keypress', function (e) {
            if (41 === e.keyCode || 93 === e.keyCode || 125 === e.keyCode) return r(t, -1)
          }),
          t.on('keyup', function (e) {
            if (32 === e.keyCode) return r(t, 0)
          }))
  })
})()
