/**
 * Copyright (c) Tiny Technologies, Inc. All rights reserved.
 * Licensed under the LGPL or a commercial license.
 * For LGPL see License.txt in the project root for license information.
 * For commercial licenses see https://www.tiny.cloud/
 *
 * Version: 5.10.5 (2022-05-25)
 */
!(function () {
  'use strict'
  function o(t, e) {
    var r = t || e,
      n = /^(\d+)([ms]?)$/.exec('' + r)
    return (n[2] ? { s: 1e3, m: 6e4 }[n[2]] : 1) * parseInt(r, 10)
  }
  function n(t) {
    var e = document.location
    return t
      .getParam('autosave_prefix', 'tinymce-autosave-{path}{query}{hash}-{id}-')
      .replace(/{path}/g, e.pathname)
      .replace(/{query}/g, e.search)
      .replace(/{hash}/g, e.hash)
      .replace(/{id}/g, t.id)
  }
    // 补充判断浏览器方法---------------
    function V(e) {
      function t(e) {
        return function () {
          return n === e
        }
      }
      var n = e.current,
        r = e.version
      return {
        current: n,
        version: r,
        isEdge: t('Edge'),
        isChrome: t('Chrome'),
        isIE: t('IE'),
        isOpera: t('Opera'),
        isFirefox: t(ne),
        isSafari: t('Safari'),
      }
    }
    function W(e) {
      function t(e) {
        return function () {
          return n === e
        }
      }
      var n = e.current,
        r = e.version
      return {
        current: n,
        version: r,
        isWindows: t(ie),
        isiOS: t('iOS'),
        isAndroid: t(ae),
        isOSX: t('OSX'),
        isLinux: t('Linux'),
        isSolaris: t(se),
        isFreeBSD: t(ue),
        isChromeOS: t(ce),
      }
    }
    function S(e) {
      return function () {
        return e
      }
    }
    function U(e, t) {
      return -1 !== e.indexOf(t)
    }
    function _(t) {
      return function (e) {
        return U(e, t)
      }
    }
    var ee = /.*?version\/\ ?([0-9]+)\.([0-9]+).*/,
    te = {
      browsers: S([
        {
          name: 'Edge',
          versionRegexes: [/.*?edge\/ ?([0-9]+)\.([0-9]+)$/],
          search: function (e) {
            return U(e, 'edge/') && U(e, 'chrome') && U(e, 'safari') && U(e, 'applewebkit')
          },
        },
        {
          name: 'Chrome',
          brand: 'Chromium',
          versionRegexes: [/.*?chrome\/([0-9]+)\.([0-9]+).*/, ee],
          search: function (e) {
            return U(e, 'chrome') && !U(e, 'chromeframe')
          },
        },
        {
          name: 'IE',
          versionRegexes: [/.*?msie\ ?([0-9]+)\.([0-9]+).*/, /.*?rv:([0-9]+)\.([0-9]+).*/],
          search: function (e) {
            return U(e, 'msie') || U(e, 'trident')
          },
        },
        {
          name: 'Opera',
          versionRegexes: [ee, /.*?opera\/([0-9]+)\.([0-9]+).*/],
          search: _('opera'),
        },
        {
          name: 'Firefox',
          versionRegexes: [/.*?firefox\/\ ?([0-9]+)\.([0-9]+).*/],
          search: _('firefox'),
        },
        {
          name: 'Safari',
          versionRegexes: [ee, /.*?cpu os ([0-9]+)_([0-9]+).*/],
          search: function (e) {
            return (U(e, 'safari') || U(e, 'mobile/')) && U(e, 'applewebkit')
          },
        },
      ]),
      oses: S([
        {
          name: 'Windows',
          search: _('win'),
          versionRegexes: [/.*?windows\ nt\ ?([0-9]+)\.([0-9]+).*/],
        },
        {
          name: 'iOS',
          search: function (e) {
            return U(e, 'iphone') || U(e, 'ipad')
          },
          versionRegexes: [
            /.*?version\/\ ?([0-9]+)\.([0-9]+).*/,
            /.*cpu os ([0-9]+)_([0-9]+).*/,
            /.*cpu iphone os ([0-9]+)_([0-9]+).*/,
          ],
        },
        {
          name: 'Android',
          search: _('android'),
          versionRegexes: [/.*?android\ ?([0-9]+)\.([0-9]+).*/],
        },
        {
          name: 'OSX',
          search: _('mac os x'),
          versionRegexes: [/.*?mac\ os\ x\ ?([0-9]+)_([0-9]+).*/],
        },
        { name: 'Linux', search: _('linux'), versionRegexes: [] },
        { name: 'Solaris', search: _('sunos'), versionRegexes: [] },
        { name: 'FreeBSD', search: _('freebsd'), versionRegexes: [] },
        {
          name: 'ChromeOS',
          search: _('cros'),
          versionRegexes: [/.*?chrome\/([0-9]+)\.([0-9]+).*/],
        },
      ]),
    },
    ne = 'Firefox',
    re = function () {
      return V({ current: void 0, version: G.unknown() })
    },
    oe = V,
    ie = (S('Edge'), S('Chrome'), S('IE'), S('Opera'), S(ne), S('Safari'), 'Windows'),
    ae = 'Android',
    se = 'Solaris',
    ue = 'FreeBSD',
    ce = 'ChromeOS',
    fe = function () {
      return W({ current: void 0, version: G.unknown() })
    }
    // ---------------
  function i(t, e) {
    if (a(e)) return t.dom.isEmpty(t.getBody())
    var r = d.trim(e)
    if ('' === r) return !0
    var n = new DOMParser().parseFromString(r, 'text/html')
    return t.dom.isEmpty(n)
  }
  function u(t) {
    var e = parseInt(v.getItem(n(t) + 'time'), 10) || 0
    return !(new Date().getTime() - e > o(t.getParam('autosave_retention'), '20m') && (g(t, !1), 1))
  }
  function s(t) {
    var e = n(t)
    !i(t) &&
      t.isDirty() &&
      (v.setItem(e + 'draft', t.getContent({ format: 'raw', no_events: !0 })),
      v.setItem(e + 'time', new Date().getTime().toString()),
      t.fire('StoreDraft'))
  }
  function f(t) {
    var e = n(t)
    u(t) && (t.setContent(v.getItem(e + 'draft'), { format: 'raw' }), t.fire('RestoreDraft'))
  }
  function c(t) {
    t.undoManager.transact(function () {
      f(t), g(t)
    }),
      t.focus()
  }
  function m(r) {
    return function (t) {
      function e() {
        return t.setDisabled(!u(r))
      }
      return (
        t.setDisabled(!u(r)),
        r.on('StoreDraft RestoreDraft RemoveDraft', e),
        function () {
          return r.off('StoreDraft RestoreDraft RemoveDraft', e)
        }
      )
    }
  }
  var t = tinymce.util.Tools.resolve('tinymce.PluginManager'),
    a = function (t) {
      return void 0 === t
    },
    l = tinymce.util.Tools.resolve('tinymce.util.Delay'),
    v = tinymce.util.Tools.resolve('tinymce.util.LocalStorage'),
    d = tinymce.util.Tools.resolve('tinymce.util.Tools'),
    g = function (t, e) {
      var r = n(t)
      v.removeItem(r + 'draft'), v.removeItem(r + 'time'), !1 !== e && t.fire('RemoveDraft')
    },
    y = tinymce.util.Tools.resolve('tinymce.EditorManager')
  t.add('autosave', function (t) {
    var e, r, n, a
    return (
      t.editorManager.on('BeforeUnload', function (t) {
        var e
        d.each(y.get(), function (t) {
          t.plugins.autosave && t.plugins.autosave.storeDraft(),
            !e &&
              t.isDirty() &&
              t.getParam('autosave_ask_before_unload', !0) &&
              (e = t.translate('You have unsaved changes are you sure you want to navigate away?'))
        }),
          e && (t.preventDefault(), (t.returnValue = e))
      }),
      (n = e = t),
      (a = o(n.getParam('autosave_interval'), '30s')),
      l.setEditorInterval(
        n,
        function () {
          s(n)
        },
        a
      ),
      e.ui.registry.addButton('restoredraft', {
        tooltip: 'Restore last draft',
        icon: 'restore-draft',
        onAction: function () {
          c(e)
        },
        onSetup: m(e),
      }),
      e.ui.registry.addMenuItem('restoredraft', {
        text: 'Restore last draft',
        icon: 'restore-draft',
        onAction: function () {
          c(e)
        },
        onSetup: m(e),
      }),
      t.on('init', function () {
        t.getParam('autosave_restore_when_empty', !1) && t.dom.isEmpty(t.getBody()) && f(t)
      }),
      (r = t),
      {
        hasDraft: function () {
          return u(r)
        },
        storeDraft: function () {
          return s(r)
        },
        restoreDraft: function () {
          return f(r)
        },
        removeDraft: function (t) {
          return g(r, t)
        },
        isEmpty: function (t) {
          return i(r, t)
        },
      }
    )
  })
})()
