/**
 * Copyright (c) Tiny Technologies, Inc. All rights reserved.
 * Licensed under the LGPL or a commercial license.
 * For LGPL see License.txt in the project root for license information.
 * For commercial licenses see https://www.tiny.cloud/
 *
 * Version: 5.10.5 (2022-05-25)
 */
!(function () {
  'use strict'
  // 补充判断浏览器方法---------------
  function V(e) {
    function t(e) {
      return function () {
        return n === e
      }
    }
    var n = e.current,
      r = e.version
    return {
      current: n,
      version: r,
      isEdge: t('Edge'),
      isChrome: t('Chrome'),
      isIE: t('IE'),
      isOpera: t('Opera'),
      isFirefox: t(ne),
      isSafari: t('Safari'),
    }
  }
  function W(e) {
    function t(e) {
      return function () {
        return n === e
      }
    }
    var n = e.current,
      r = e.version
    return {
      current: n,
      version: r,
      isWindows: t(ie),
      isiOS: t('iOS'),
      isAndroid: t(ae),
      isOSX: t('OSX'),
      isLinux: t('Linux'),
      isSolaris: t(se),
      isFreeBSD: t(ue),
      isChromeOS: t(ce),
    }
  }
  function S(e) {
    return function () {
      return e
    }
  }
  function U(e, t) {
    return -1 !== e.indexOf(t)
  }
  function _(t) {
    return function (e) {
      return U(e, t)
    }
  }
  var ee = /.*?version\/\ ?([0-9]+)\.([0-9]+).*/,
    te = {
      browsers: S([
        {
          name: 'Edge',
          versionRegexes: [/.*?edge\/ ?([0-9]+)\.([0-9]+)$/],
          search: function (e) {
            return U(e, 'edge/') && U(e, 'chrome') && U(e, 'safari') && U(e, 'applewebkit')
          },
        },
        {
          name: 'Chrome',
          brand: 'Chromium',
          versionRegexes: [/.*?chrome\/([0-9]+)\.([0-9]+).*/, ee],
          search: function (e) {
            return U(e, 'chrome') && !U(e, 'chromeframe')
          },
        },
        {
          name: 'IE',
          versionRegexes: [/.*?msie\ ?([0-9]+)\.([0-9]+).*/, /.*?rv:([0-9]+)\.([0-9]+).*/],
          search: function (e) {
            return U(e, 'msie') || U(e, 'trident')
          },
        },
        {
          name: 'Opera',
          versionRegexes: [ee, /.*?opera\/([0-9]+)\.([0-9]+).*/],
          search: _('opera'),
        },
        {
          name: 'Firefox',
          versionRegexes: [/.*?firefox\/\ ?([0-9]+)\.([0-9]+).*/],
          search: _('firefox'),
        },
        {
          name: 'Safari',
          versionRegexes: [ee, /.*?cpu os ([0-9]+)_([0-9]+).*/],
          search: function (e) {
            return (U(e, 'safari') || U(e, 'mobile/')) && U(e, 'applewebkit')
          },
        },
      ]),
      oses: S([
        {
          name: 'Windows',
          search: _('win'),
          versionRegexes: [/.*?windows\ nt\ ?([0-9]+)\.([0-9]+).*/],
        },
        {
          name: 'iOS',
          search: function (e) {
            return U(e, 'iphone') || U(e, 'ipad')
          },
          versionRegexes: [
            /.*?version\/\ ?([0-9]+)\.([0-9]+).*/,
            /.*cpu os ([0-9]+)_([0-9]+).*/,
            /.*cpu iphone os ([0-9]+)_([0-9]+).*/,
          ],
        },
        {
          name: 'Android',
          search: _('android'),
          versionRegexes: [/.*?android\ ?([0-9]+)\.([0-9]+).*/],
        },
        {
          name: 'OSX',
          search: _('mac os x'),
          versionRegexes: [/.*?mac\ os\ x\ ?([0-9]+)_([0-9]+).*/],
        },
        { name: 'Linux', search: _('linux'), versionRegexes: [] },
        { name: 'Solaris', search: _('sunos'), versionRegexes: [] },
        { name: 'FreeBSD', search: _('freebsd'), versionRegexes: [] },
        {
          name: 'ChromeOS',
          search: _('cros'),
          versionRegexes: [/.*?chrome\/([0-9]+)\.([0-9]+).*/],
        },
      ]),
    },
    ne = 'Firefox',
    re = function () {
      return V({ current: void 0, version: G.unknown() })
    },
    oe = V,
    ie = (S('Edge'), S('Chrome'), S('IE'), S('Opera'), S(ne), S('Safari'), 'Windows'),
    ae = 'Android',
    se = 'Solaris',
    ue = 'FreeBSD',
    ce = 'ChromeOS',
    fe = function () {
      return W({ current: void 0, version: G.unknown() })
    }
  // ---------------
  tinymce.util.Tools.resolve('tinymce.PluginManager').add('hr', function (n) {
    var o, t
    function e() {
      return t.execCommand('InsertHorizontalRule')
    }
    ;(o = n).addCommand('InsertHorizontalRule', function () {
      o.execCommand('mceInsertContent', !1, '<hr />')
    }),
      (t = n).ui.registry.addButton('hr', {
        icon: 'horizontal-rule',
        tooltip: 'Horizontal line',
        onAction: e,
      }),
      t.ui.registry.addMenuItem('hr', {
        icon: 'horizontal-rule',
        text: 'Horizontal line',
        onAction: e,
      })
  })
})()
