/**
 * Copyright (c) Tiny Technologies, Inc. All rights reserved.
 * Licensed under the LGPL or a commercial license.
 * For LGPL see License.txt in the project root for license information.
 * For commercial licenses see https://www.tiny.cloud/
 *
 * Version: 5.10.5 (2022-05-25)
 */
!(function () {
  'use strict'
  // 补充判断浏览器方法---------------
  function V(e) {
    function t(e) {
      return function () {
        return n === e
      }
    }
    var n = e.current,
      r = e.version
    return {
      current: n,
      version: r,
      isEdge: t('Edge'),
      isChrome: t('Chrome'),
      isIE: t('IE'),
      isOpera: t('Opera'),
      isFirefox: t(ne),
      isSafari: t('Safari'),
    }
  }
  function W(e) {
    function t(e) {
      return function () {
        return n === e
      }
    }
    var n = e.current,
      r = e.version
    return {
      current: n,
      version: r,
      isWindows: t(ie),
      isiOS: t('iOS'),
      isAndroid: t(ae),
      isOSX: t('OSX'),
      isLinux: t('Linux'),
      isSolaris: t(se),
      isFreeBSD: t(ue),
      isChromeOS: t(ce),
    }
  }
  function S(e) {
    return function () {
      return e
    }
  }
  function U(e, t) {
    return -1 !== e.indexOf(t)
  }
  function _(t) {
    return function (e) {
      return U(e, t)
    }
  }
  var ee = /.*?version\/\ ?([0-9]+)\.([0-9]+).*/,
    te = {
      browsers: S([
        {
          name: 'Edge',
          versionRegexes: [/.*?edge\/ ?([0-9]+)\.([0-9]+)$/],
          search: function (e) {
            return U(e, 'edge/') && U(e, 'chrome') && U(e, 'safari') && U(e, 'applewebkit')
          },
        },
        {
          name: 'Chrome',
          brand: 'Chromium',
          versionRegexes: [/.*?chrome\/([0-9]+)\.([0-9]+).*/, ee],
          search: function (e) {
            return U(e, 'chrome') && !U(e, 'chromeframe')
          },
        },
        {
          name: 'IE',
          versionRegexes: [/.*?msie\ ?([0-9]+)\.([0-9]+).*/, /.*?rv:([0-9]+)\.([0-9]+).*/],
          search: function (e) {
            return U(e, 'msie') || U(e, 'trident')
          },
        },
        {
          name: 'Opera',
          versionRegexes: [ee, /.*?opera\/([0-9]+)\.([0-9]+).*/],
          search: _('opera'),
        },
        {
          name: 'Firefox',
          versionRegexes: [/.*?firefox\/\ ?([0-9]+)\.([0-9]+).*/],
          search: _('firefox'),
        },
        {
          name: 'Safari',
          versionRegexes: [ee, /.*?cpu os ([0-9]+)_([0-9]+).*/],
          search: function (e) {
            return (U(e, 'safari') || U(e, 'mobile/')) && U(e, 'applewebkit')
          },
        },
      ]),
      oses: S([
        {
          name: 'Windows',
          search: _('win'),
          versionRegexes: [/.*?windows\ nt\ ?([0-9]+)\.([0-9]+).*/],
        },
        {
          name: 'iOS',
          search: function (e) {
            return U(e, 'iphone') || U(e, 'ipad')
          },
          versionRegexes: [
            /.*?version\/\ ?([0-9]+)\.([0-9]+).*/,
            /.*cpu os ([0-9]+)_([0-9]+).*/,
            /.*cpu iphone os ([0-9]+)_([0-9]+).*/,
          ],
        },
        {
          name: 'Android',
          search: _('android'),
          versionRegexes: [/.*?android\ ?([0-9]+)\.([0-9]+).*/],
        },
        {
          name: 'OSX',
          search: _('mac os x'),
          versionRegexes: [/.*?mac\ os\ x\ ?([0-9]+)_([0-9]+).*/],
        },
        { name: 'Linux', search: _('linux'), versionRegexes: [] },
        { name: 'Solaris', search: _('sunos'), versionRegexes: [] },
        { name: 'FreeBSD', search: _('freebsd'), versionRegexes: [] },
        {
          name: 'ChromeOS',
          search: _('cros'),
          versionRegexes: [/.*?chrome\/([0-9]+)\.([0-9]+).*/],
        },
      ]),
    },
    ne = 'Firefox',
    re = function () {
      return V({ current: void 0, version: G.unknown() })
    },
    oe = V,
    ie = (S('Edge'), S('Chrome'), S('IE'), S('Opera'), S(ne), S('Safari'), 'Windows'),
    ae = 'Android',
    se = 'Solaris',
    ue = 'FreeBSD',
    ce = 'ChromeOS',
    fe = function () {
      return W({ current: void 0, version: G.unknown() })
    }
  // ---------------
  function l(e) {
    return e.getParam('insertdatetime_timeformat', e.translate('%H:%M:%S'))
  }
  function s(e) {
    return e.getParam('insertdatetime_formats', ['%H:%M:%S', '%Y-%m-%d', '%I:%M:%S %p', '%D'])
  }
  function r(e, t) {
    if ((e = '' + e).length < t) for (var n = 0; n < t - e.length; n++) e = '0' + e
    return e
  }
  function d(e, t, n) {
    return (
      void 0 === n && (n = new Date()),
      (t = (t = (t = (t = (t = (t = (t = (t = (t = (t = (t = (t = (t = (t = (t = t.replace(
        '%D',
        '%m/%d/%Y'
      )).replace('%r', '%I:%M:%S %p')).replace('%Y', '' + n.getFullYear())).replace(
        '%y',
        '' + n.getYear()
      )).replace('%m', r(n.getMonth() + 1, 2))).replace('%d', r(n.getDate(), 2))).replace(
        '%H',
        '' + r(n.getHours(), 2)
      )).replace('%M', '' + r(n.getMinutes(), 2))).replace(
        '%S',
        '' + r(n.getSeconds(), 2)
      )).replace('%I', '' + (((n.getHours() + 11) % 12) + 1))).replace(
        '%p',
        n.getHours() < 12 ? 'AM' : 'PM'
      )).replace('%B', '' + e.translate(u[n.getMonth()]))).replace(
        '%b',
        '' + e.translate(o[n.getMonth()])
      )).replace('%A', '' + e.translate(i[n.getDay()]))).replace(
        '%a',
        '' + e.translate(a[n.getDay()])
      )).replace('%%', '%')
    )
  }
  function p(e, t) {
    var n, r, a, i, o, u
    e.getParam('insertdatetime_element', !1)
      ? ((n = d(e, t)),
        (r = /%[HMSIp]/.test(t) ? d(e, '%Y-%m-%dT%H:%M') : d(e, '%Y-%m-%d')),
        (a = e.dom.getParent(e.selection.getStart(), 'time'))
          ? ((o = a),
            (u = (i = e).dom.create('time', { datetime: r }, n)),
            o.parentNode.insertBefore(u, o),
            i.dom.remove(o),
            i.selection.select(u, !0),
            i.selection.collapse(!1))
          : e.insertContent('<time datetime="' + r + '">' + n + '</time>'))
      : e.insertContent(d(e, t))
  }
  var e = tinymce.util.Tools.resolve('tinymce.PluginManager'),
    a = 'Sun Mon Tue Wed Thu Fri Sat Sun'.split(' '),
    i = 'Sunday Monday Tuesday Wednesday Thursday Friday Saturday Sunday'.split(' '),
    o = 'Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec'.split(' '),
    u =
      'January February March April May June July August September October November December'.split(
        ' '
      ),
    g = tinymce.util.Tools.resolve('tinymce.util.Tools')
  e.add('insertdatetime', function (e) {
    var n, r, t, a, i, o, u, c
    function m(e) {
      return r.execCommand('mceInsertDate', !1, e)
    }
    ;(n = e).addCommand('mceInsertDate', function (e, t) {
      p(n, null != t ? t : n.getParam('insertdatetime_dateformat', n.translate('%Y-%m-%d')))
    }),
      n.addCommand('mceInsertTime', function (e, t) {
        p(n, null != t ? t : l(n))
      }),
      (u = s((r = e))),
      (t = 0 < (o = s((i = r))).length ? o[0] : l(i)),
      (a = t),
      (c = {
        get: function () {
          return a
        },
        set: function (e) {
          a = e
        },
      }),
      r.ui.registry.addSplitButton('insertdatetime', {
        icon: 'insert-time',
        tooltip: 'Insert date/time',
        select: function (e) {
          return e === c.get()
        },
        fetch: function (e) {
          e(
            g.map(u, function (e) {
              return { type: 'choiceitem', text: d(r, e), value: e }
            })
          )
        },
        onAction: function (e) {
          m(c.get())
        },
        onItemAction: function (e, t) {
          c.set(t), m(t)
        },
      }),
      r.ui.registry.addNestedMenuItem('insertdatetime', {
        icon: 'insert-time',
        text: 'Date/time',
        getSubmenuItems: function () {
          return g.map(u, function (e) {
            return {
              type: 'menuitem',
              text: d(r, e),
              onAction:
                ((t = e),
                function () {
                  c.set(t), m(t)
                }),
            }
            var t
          })
        },
      })
  })
})()
