import { defineConfig } from 'vite';
import vue from '@vitejs/plugin-vue';
import * as path from 'path'

export default defineConfig({
  plugins: [vue()],
  build: {
    outDir: 'dist',
    lib: {
      entry: path.resolve(__dirname, 'src/packages/Editor/index.ts'),
      name: 'vue3TinymceEditor',
      fileName: 'vue3-tinymce-editor',
    },
    rollupOptions: {
      // 确保外部化处理那些你不想打包进库的依赖
      external: ['vue'],
      output: {
        // 在 UMD 构建模式下为这些外部化的依赖提供一个全局变量
        globals: {
          vue: 'Vue',
        },
      },
    },
  },
});